"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAtom = exports.Atom = void 0;
class Atom {
    _value;
    _subscriptions;
    constructor(initialValue) {
        this._value = initialValue;
        this._subscriptions = [];
        this.subscribe = this.subscribe.bind(this);
    }
    get value() {
        return this._value;
    }
    set value(value) {
        this._value = value;
        this._subscriptions.forEach((cb) => cb(value));
    }
    subscribe(subscription) {
        this._subscriptions = [...this._subscriptions, subscription];
        return () => {
            this._subscriptions = this._subscriptions.filter((cb) => cb !== subscription);
        };
    }
}
exports.Atom = Atom;
const createAtom = (initialValue) => new Atom(initialValue);
exports.createAtom = createAtom;
//# sourceMappingURL=Atom.js.map