import type { Atom } from './Atom';
export declare type SetAtomValue<T> = T extends Function ? ((prevState: T) => T) : T | ((prevState: T) => T);
/** React hook that returns the stateful value of an atom and a function to update it  */
export declare const useAtom: <T>(atom: Atom<T>) => [T, (value: SetAtomValue<T>) => void];
